# Contributing to Eval

## 👍🎉 First off, thanks for taking the time to contribute! 🎉👍

**You are more than welcomed to do so!**

The following is a set of guidelines and best practices for contributing to Eval. These are mostly guidelines, not rules. Use your best judgment, and feel free to propose changes to this document in a Pull Request.

## Code of Conduct

Nothing serious, all I ask is to be respectful and as helpful as you would expect others commnicating with you.

## I don't want to read this whole thing, I just have a question!

The easiest channel is Twitter. You can reach out to me `@tevelee`, or feel free to write a mail at `tevelee [at] gmail [dot] com`.

If you have bigger concerns, feel free to write a GitHub issue. 

## What should I know before I get started?

First of all, please read the [documentation pages](Documentation), and feel free to check out the examples. 

There are a few things you need to be aware of when contributing:

* The repository is only opened to a very selected set of contributors. If you need any code modifications, you need to fork and create a Pull Request.
* There is a CI up and running
* I use SwiftLint with build-in rules to keep the code as nice as possible
* There is Danger configured with some rules, auto-checking contributions before I do
* I intend to keep the code test coverage as high as possible. Please be mindful about this when contributing

# How Can I Contribute?

## Reporting Bugs or Suggesting Enhancements

Feel free to use the same channels as I described in the README: 

The easiest channel is Twitter. You can reach out to me `@tevelee`, or feel free to write a mail at `tevelee [at] gmail [dot] com`.

If you have bigger concerns, feel free to write a GitHub issue. 

## Pull Requests

### Git Commit Messages

Please use git rebase keep your number commits as low as possible.

### Documentation Styleguide

I use a standard style of markdown pages in the [README.md](README.md) and in the [Documentation folder](Documentation).

I also document the code, most importantly the public interfaces. I intend to keep the line documentation coverage of the publicly available methods and classes a 100%.

### Issue and Pull Request Labels

No rules you need to be aware of
